routes/web.php
Route::match(['get', 'post'], 'email-campaign/{id}/import', 'EmailMarketing\EmailCampaignController@import')->name('email-campaign.import');
Route::get('email-list/{id}/export', 'EmailMarketing\EmailListController@export')->name('email-list.export');
Route::resource('email-list', 'EmailMarketing\EmailListController');
Route::get('email-campaign/{id}/showPdf', 'EmailMarketing\EmailCampaignController@showPdf')->name('email-campaign.showPdf');
Route::get('email-campaign/{id}/genPdf', 'EmailMarketing\EmailCampaignController@genPdf')->name('email-campaign.genPdf');
Route::get('email-campaign/{id}/regenAllPdf', 'EmailMarketing\EmailCampaignController@regenAllPdf')->name('email-campaign.regenAllPdf');
Route::get('email-campaign/{id}/genAllPdf', 'EmailMarketing\EmailCampaignController@genAllPdf')->name('email-campaign.genAllPdf');
Route::match(['get', 'post'], 'email-template/{id}/edit', 'EmailMarketing\EmailCampaignController@editEmailTemplate')->name('email-template.edit');
Route::resource('email-template', 'EmailMarketing\EmailTemplateController');
Route::get('email-campaign/{id}/showEmail', 'EmailMarketing\EmailCampaignController@showEmail')->name('email-campaign.showEmail');
Route::get('email-campaign/{id}/sendEmail', 'EmailMarketing\EmailCampaignController@sendEmail')->name('email.send');
Route::get('email-campaign/{id}/resend', 'EmailMarketing\EmailCampaignController@resend')->name('email.resend');
Route::get('email-campaign/{id}/sendTestEmail', 'EmailMarketing\EmailCampaignController@sendTestEmail')->name('email.sendTestEmail');
Route::get('email-campaign/{id}/progress', 'EmailMarketing\EmailCampaignController@progress')->name('email.progress');
Route::get('email-campaign/{id}/sendPrivateEmail', 'EmailMarketing\EmailCampaignController@sendPrivateEmail')->name('email.sendPrivate');
Route::resource('email-campaign', 'EmailMarketing\EmailCampaignController');
//Route::post('lead/{data?}', 'LeadController@index');
Route::match(['get', 'post'], 'lead/import', 'LeadController@import')->middleware('auth');

$s = 'social.';
Route::get('/social/redirect/{provider}', ['as' => $s . 'redirect', 'uses' => 'Auth\SocialController@getSocialRedirect']);
Route::get('/social/handle/{provider}', ['as' => $s . 'handle', 'uses' => 'Auth\SocialController@getSocialHandle']);

Route::get('ami', 'AsteriskController@call');
Auth::routes();

Route::get('/home', 'LeadController@index')->middleware('auth');
Route::get('/lead/index', 'LeadController@index')->middleware('auth');
Route::get('/report/campaign', 'ReportController@campaign')->name('report.campaign')->middleware('auth');
Route::get('/test', 'TestController@test')->name('test.test');
Route::get('/parse', 'TestController@parse_grade')->name('test.parse');
Route::get('/authorize', 'TestController@authorizeGoogle')->name('test.authorize');
Route::get('/report/online', 'ReportController@showOnlineStatus')->name('report.online')->middleware('auth');
Route::match(['get', 'post'], '/report/call_summary', 'ReportController@showCallSummaryReport')->name('report.call_summary')->middleware('auth');
Route::match(['get', 'post'], '/report/dmr', 'ReportController@showDmrReport')->name('report.dmr')->middleware('auth');
Route::get('/report/performance', 'ReportController@performance')->name('report.performance')->middleware('auth');
Route::match(['get', 'post'], '/report/lead', 'ReportController@showLeadReport')->name('report.lead')->middleware('auth');
Route::get('/utils/getSchools/{province}', 'UtilsController@getSchools');
Route::get('/utils/getSchools/{province}/{selected}', 'UtilsController@getSchools');
Route::get('/utils/getDistricts/{province}', 'UtilsController@getDistricts');
Route::get('/utils/getDistricts/{province}/{selected}', 'UtilsController@getDistricts');
Route::get('/utils/checkIfPhoneExists/{phone}', 'UtilsController@checkIfPhoneExists');
Route::get('/utils/getOnline/{user_id}', 'UtilsController@getOnline');
Route::get('/utils/getWeight', 'UtilsController@getWeight');
Route::get('/utils/getLeadCost', 'UtilsController@getLeadCost');
Route::get('/utils/checkCost', 'UtilsController@checkCost');
Route::get('/utils/checkList', 'UtilsController@checkList');
Route::get('/utils/getOnlineUsers', 'UtilsController@getOnlineUsers');
Route::get('/utils/fixAssignment', 'UtilsController@fix_assignment');
Route::get('/utils/setOnline/{user_id}', 'UtilsController@setOnline');
Route::get('/call/{phone}/{trunk?}', 'LeadController@call')->name('lead.call')->middleware('auth');
Route::get('/call_test/{phone}/{trunk?}', 'LeadController@call_test')->name('lead.call_test')->middleware('auth');
Route::get('/utils/getOnlineStatus/{user_id}', 'UtilsController@getOnlineStatus');
Route::match(['get', 'post'], '/sms/send', 'UtilsController@sendSms');
Route::resource('cost', 'MarketingCostController');
Route::resource('alarm', 'AlarmController');
Route::resource('cdr', 'CdrController');
Route::resource('class', 'AvailableClassController');
Route::get('class/{id}/toggle', 'AvailableClassController@toggle')->name('class.toggle')->middleware('auth');
Route::resource('source', 'SourceController');
Route::get('lead_status/{id}/toggle', 'LeadStatusController@toggle')->name('lead_status.toggle')->middleware('auth');
Route::resource('lead_status', 'LeadStatusController');
Route::get('call_status/{id}/toggle', 'CallStatusController@toggle')->name('call_status.toggle')->middleware('auth');
Route::resource('call_status', 'CallStatusController');
Route::get('source/{id}/toggle', 'SourceController@toggle')->name('source.toggle')->middleware('auth');
Route::resource('info_source', 'InfoSourceController');
Route::get('info_source/{id}/toggle', 'InfoSourceController@toggle')->name('info_source.toggle')->middleware('auth');
Route::resource('channel', 'ChannelController');
Route::get('channel/{id}/toggle', 'ChannelController@toggle')->name('channel.toggle')->middleware('auth');
Route::resource('campaign', 'CampaignController');
Route::get('campaign/{id}/toggle', 'CampaignController@toggle')->name('campaign.toggle')->middleware('auth');
Route::resource('campus', 'CampusController');
Route::get('campus/{id}/toggle', 'CampusController@toggle')->name('campus.toggle')->middleware('auth');
Route::resource('department', 'DepartmentController');
Route::get('department/{id}/toggle', 'DepartmentController@toggle')->name('department.toggle')->middleware('auth');
Route::resource('school', 'SchoolController');
Route::get('school/{id}/toggle', 'SchoolController@toggle')->name('school.toggle')->middleware('auth');
Route::resource('promotion', 'PromotionController');
Route::get('promotion/{id}/toggle', 'PromotionController@toggle')->name('promotion.toggle')->middleware('auth');
Route::post('alarm/set', 'AlarmController@set')->name('alarm.set')->middleware('auth');
Route::post('alarm/stop', 'AlarmController@stopAlarm')->name('alarm.stop')->middleware('auth');
Route::get('alarm/{user_id}/list', 'AlarmController@getAlarmList')->name('alarm.list')->middleware('auth');
Route::resource('sms', 'SmsController');
Route::resource('alarm', 'AlarmController')->middleware('auth');
Route::post('sms/stop', 'SmsController@stopSmsNotification')->name('sms.stop')->middleware('auth');
Route::get('sms/{user_id}/list', 'SmsController@getUnopenedSmsList')->name('sms.list')->middleware('auth');
Route::get('transfer/{department_id}/show', 'TransferredLeadController@showList')->name('transfer.show')->middleware('auth');
Route::get('transfer/notified', 'TransferredLeadController@notified')->name('transfer.notified')->middleware('auth');
Route::get('email/{id}/open', 'EmailMarketing\EmailController@open')->name('email.open');
Route::get('forceReload', 'UtilsController@forceReload');
Route::get('needReload', 'UtilsController@getForceReloadStatus');
Route::post('call_history/log', 'CallLogController@log');
Route::resource('calls', 'CallLogController');
Route::match(['get', 'post'], 'suspect/import', 'SuspectController@import')->name('suspect.import');
Route::resource('suspect', 'SuspectController');
Route::match(['get', 'post'], 'report/call_log', 'Report\CallLogReportController@index')->name('report.call_log');
Route::match(['get', 'post'], 'report/call_log/test', 'Report\CallLogReportController@test')->name('report.call_log.test');
Route::match(['get', 'post'], 'report/call_log/getUserByDepartment', 'Report\CallLogReportController@getUserByDepartment')->name('report.call_log.get_user_by_department');
Route::post('lead/sendSms', 'LeadController@sendSms')->name('lead.sms')->middleware('auth');
Route::post('lead/sendSmsMultiple', 'LeadController@sendSmsMultiple')->name('lead.sms_multiple')->middleware('auth');
Route::post('lead/getUserByDepartment', 'LeadController@getUserByDepartment')->name('lead.get_user_by_department')->middleware('auth');
Route::post('lead/getCampaignByCategory', 'LeadController@getCampaignByCategory')->name('lead.getCampaignByCategory')->middleware('auth');

Route::match(['get', 'post'], 'report/logSms', 'Report\LogSmsController@index')->name('report.logSms');
Route::match(['get', 'post'], 'report/logSms/detail', 'Report\LogSmsController@detail')->name('report.logSms.detail');
Route::match(['get', 'post'], 'report/leadInteractive', 'Report\LeadInteractiveController@index')->name('report.leadInteractive');
Route::match(['get', 'post'], 'report/leadInteractiveExport', 'Report\LeadInteractiveController@export')->name('report.leadInteractive.export');
Route::match(['get', 'post'], 'leadMarketing/landingPage', 'LeadMarketing\LandingPageController@index')->name('leadMarketing.landingPage');
Route::match(['get', 'post'], 'leadMarketing/website', 'LeadMarketing\WebsiteController@index')->name('leadMarketing.website');
Route::match(['get', 'post'], 'leadMarketing/facebook', 'LeadMarketing\FacebookController@index')->name('leadMarketing.facebook');
Route::match(['get', 'post'], 'leadMarketing/tawkto', 'LeadMarketing\TawktoController@index')->name('leadMarketing.tawkto');

app/School.php
<?php
/**
 * Created by PhpStorm.
 * User: ledaihoang
 * Date: 24/11/2017
 * Time: 2:39 PM
 */

namespace App;

use Illuminate\Database\Eloquent\Model;

class School extends Model
{
    protected $table = 'fptu_school';
    protected $fillable = array('name', 'type', 'address', 'province');


    public static function listData($province = null)
    {
        $data = (!empty($province))
            ? self::where('province', $province)->get()->pluck('name','id')
            : self::all()->pluck('name','id');
        return $data;
    }
}

app/SchoolType.php
<?php
/**
 * Created by PhpStorm.
 * User: ledaihoang
 * Date: 24/11/2017
 * Time: 2:39 PM
 */

namespace App;

use Illuminate\Database\Eloquent\Model;

class SchoolType extends Model
{
    protected $table = 'edf_school_type';
}

app/Http/Controllers/SchoolController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\School;
use App\SchoolType;
use App\Province;
use App\Department;
use Illuminate\Support\Facades\Auth;

class SchoolController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $school_list = array();
        if (Auth::user()->hasRole('admin'))
            $school_list = School::orderBy('type', 'asc')->orderBy('name', 'asc')->get();
        else
            $school_list = School::where('province', Department::find(Auth::user()->department_id)->province)->orderBy('type', 'asc')->orderBy('name', 'asc')->get();
        $province_list = Province::all()->pluck('name', 'id');
        $school_type_list = SchoolType::all()->pluck('name', 'id');
        return view('school.index', ['school_list' => $school_list, 'province_list' => $province_list, 'school_type_list' => $school_type_list]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $school_type_list = SchoolType::all()->pluck('name', 'id');
        $province_list = Province::all()->pluck('name', 'id');
        return view('school.create', ['province_list' => $province_list, 'school_type_list' => $school_type_list]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $success = 0;
        $return_message = '';
        $province_list = Province::all()->pluck('name', 'id');
        $school_type_list = SchoolType::all()->pluck('name', 'id');
        $found = School::where('name', $request->name)
            ->count();
        $error = false;
        if ($found) {
            $return_message = 'Tên trường đã tồn tại.';
            $error = true;
        } else {
            $return_message = 'Tạo trường mới thành công!';
            $success = 1;
            $school = new School();
            $school->name = trim($request->name);
            $school->type = trim($request->type);
            $school->province = $request->province;
            $school->address = trim($request->address);
            $saved = $school->save();
            if (!$saved) {
                $return_message = 'Đã có lỗi trong quá trình lưu dữ liệu!';
                $success = 0;
                $error = true;
            }
        }
        $request->flash();
        if ($error)
            return view('school.create', ['success' => $success, 'message' => $return_message]);
        return view('school.edit', ['school' => $school, 'province_list' => $province_list, 'success' => $success, 'message' => $return_message, 'school_type_list' => $school_type_list]);
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $school = School::find($id);
        $province_list = Province::all()->pluck('name', 'id');
        $school_type_list = SchoolType::all()->pluck('name', 'id');
        return view('school.edit', ['school' => $school, 'province_list' => $province_list, 'school_type_list' => $school_type_list]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $success = 0;
        $school = School::find($id);
        $error = false;
        $return_message = '';
        $school->name = trim($request->name);
        $school->type = trim($request->type);
        $school->address = trim($request->address);
        $school->province = $request->province;
        $province_list = Province::all()->pluck('name', 'id');
        $school_type_list = SchoolType::all()->pluck('name', 'id');
        $updated = $school->save();
        if ($updated) {
            $return_message = 'Đã cập nhật dữ liệu thành công!';
            $success = 1;
        } else {
            $return_message = '<div>Đã có lỗi trong quá trình cập nhật dữ liệu.</div>';
            $success = 0;
        }
        return view('school.edit', ['success' => $success, 'school' => $school, 'province_list' => $province_list, 'message' => $return_message, 'school_type_list' => $school_type_list]);
    }

    public function toggle($id)
    {
        $success = 0;
        $school = School::find($id);
        $error = false;
        $return_message = '';
        $update = array();
        $province_list = Province::all()->pluck('name', 'id');
        $school_type_list = SchoolType::all()->pluck('name', 'id');
        if ($school->hide == 1) {
            $school->hide = 0;
        } else {
            $school->hide = 1;
        }
        $updated = $school->save();
        if ($updated) {
            $return_message = 'Đã cập nhật trạng thái lớp thành công!';
            $success = 1;
        } else {
            $return_message = 'Đã có lỗi trong quá trình cập nhật dữ liệu.';
            $success = 0;
        }
//        $school_list = array();
//        $school_list = School::all();
//        return view('school.index', ['success' => $success, 'message' => $return_message, 'school_list' => $school_list, 'province_list' => $province_list, 'school_type_list' => $school_type_list]);
        return redirect('school');
    }
}

resources/views/school/create.blade.php
@extends('layouts.main')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Thêm trường mới</div>
                <div class="panel-body">
                    @if(!empty($message))
                        <div class="alert {!! $success == 1?'alert-success':'alert-danger' !!}"
                             role="alert">{!! $message !!}</div>
                    @endif
                    <form class="form-horizontal" role="form" method="POST" action="{{ route('school.store') }}">
                        {{ csrf_field() }}


                        <div class="form-group{{ $errors->has('name') ? ' has-error' : '' }}">
                            <label for="name" class="col-md-4 control-label required">Tên trường</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control" name="name"
                                       value="{{ old('name') }}" required autofocus>

                                @if ($errors->has('name'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('name') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('type') ? ' has-error' : '' }}">
                            <label for="type" class="col-md-4 control-label required">Loại trường</label>

                            <div class="col-md-6">
                                {{ Form::select('type', $school_type_list, old('type'), ['id' => 'type', 'multiple' => true, 'class' => 'form-control', 'required' => 'required']) }}

                                @if ($errors->has('type'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('type') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('address') ? ' has-error' : '' }}">
                            <label for="address" class="col-md-4 control-label">Địa chỉ</label>

                            <div class="col-md-6">
                                <input id="address" type="text" class="form-control" name="address"
                                       value="{{ old('address') }}" autofocus>

                                @if ($errors->has('address'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('address') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('province') ? ' has-error' : '' }}">
                            <label for="province" class="col-md-4 control-label required">Tinh/thành phố</label>

                            <div class="col-md-6">
                                {{ Form::select('province', $province_list, old('province'), ['id' => 'province', 'multiple' => true, 'class' => 'form-control', 'required' => 'required']) }}

                                @if ($errors->has('province'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('province') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>


                        <div class="form-group">
                            <div class="col-md-6 col-md-offset-4">
                                <button type="submit" class="btn btn-primary">
                                    Khởi tạo
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@stop

resources/views/school/edit.blade.php
@extends('layouts.main')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Chỉnh sửa trường</div>
                <div class="panel-body">
                    @if(!empty($message))
                        <div class="alert {!! $success == 1?'alert-success':'alert-danger' !!}"
                             role="alert">{!! $message !!}</div>
                    @endif
                    <form class="form-horizontal" role="form" method="POST"
                          action="{{ route('school.update', $school->id) }}">
                        {!! method_field('patch') !!}
                        {{ csrf_field() }}
                        <div class="form-group{{ $errors->has('name') ? ' has-error' : '' }}">
                            <label for="name" class="col-md-4 control-label">Tên cơ sở</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control" name="name"
                                       value="{{ $school->name }}" required autofocus>

                                @if ($errors->has('name'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('name') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('type') ? ' has-error' : '' }}">
                            <label for="type" class="col-md-4 control-label required">Loại trường</label>

                            <div class="col-md-6">
                                {{ Form::select('type', $school_type_list, !empty($school->type)?$school->type:old('type'), ['id' => 'type', 'multiple' => true, 'class' => 'form-control', 'required' => 'required']) }}

                                @if ($errors->has('type'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('type') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('address') ? ' has-error' : '' }}">
                            <label for="address" class="col-md-4 control-label">Địa chỉ</label>

                            <div class="col-md-6">
                                <input id="address" type="text" class="form-control" name="address"
                                       value="{{ !empty($school->address)?$school->address:old('address') }}" autofocus>

                                @if ($errors->has('address'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('address') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('province') ? ' has-error' : '' }}">
                            <label for="province" class="col-md-4 control-label">Tỉnh/thành
                                phố</label>

                            <div class="col-md-6">
                                {{ Form::select('province', $province_list, !empty($school->province)?$school->province:old('province'), ['id' => 'province', 'multiple' => true, 'class' => 'form-control']) }}
                                @if ($errors->has('province'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('province') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>


                        <div class="form-group">
                            <div class="col-md-6 col-md-offset-4">
                                <button type="submit" class="btn btn-primary">
                                    Cập nhật
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@stop

resources/views/school/index.blade.php
@extends('layouts.main')

@section('content')

<div class="x_panel">
    <div class="x_title">
        <h2>Quản lý trường</h2>
        <div class="pull-right">
            <a class="btn btn-default" href="{{ route('school.create') }}">Thêm trường mới</a><br/>
        </div>
        <div class="clearfix"></div>
    </div>
    <div class="x_content">
        <table class="table table-hover">
            <thead>
            <th></th>
            <th></th>
            <th>Loại trường</th>
            <th>Tên trường</th>
            <th>Địa chỉ</th>
            <th>Tỉnh</th>
            </thead>
            <tbody>
            @foreach($school_list as $school)
                <tr>
                    <td><a href="{{ route('school.edit', $school->id) }}" title="Chỉnh sửa"><i
                                    class="fa fa-lg fa-pencil"
                                    aria-hidden="true"></i></a>
                    </td>
                    <td><a href="{{ route('school.toggle', $school->id) }}"
                           title="{!! $school->hide ?'Hiện' : 'Ẩn' !!}"><i
                                    class="fa fa-lg {!! $school->hide ?'fa-eye' : 'fa-eye-slash' !!}"
                                    aria-hidden="true"></i></a></td>
                    <td>{{ !empty($school->type)?App\SchoolType::find($school->type)->name:'' }}</td>
                    <td>{{ $school->name }}</td>
                    <td>{{ $school->address }}</td>
                    <td>{{ !empty($school->province)?$province_list[$school->province]:'' }}</td>
                    <td>{!! !empty($school->hide) ?'<span class="class-status active">Ẩn</span>':'<span class="class-status inactive">Hiện</span>' !!}</td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
</div>
@stop